﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows.Input;
using Infragistics.Controls.Editors;
using System.Globalization;

namespace WpfApplication2
{
    public class ArrayConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            Tuple<object, object> tuple = new Tuple<object, object>(
           values[0], values[1]);
            return (object)tuple;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            return null;
        }
    }

    public class CheckAllCommand : ICommand
    {
        public void Execute(object parameter)
        {
            Tuple<object, object> param = (Tuple<object, object>)parameter;
            XamComboEditor combo = param.Item1 as XamComboEditor;
            bool select = (bool)param.Item2;

            foreach (ComboEditorItem i in combo.Items)
            {
                i.IsSelected = select;
            }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;
    }
    public class CheckBoxIsCheckedConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            XamComboEditor comboEditor = null;
            int selectedCount = -1;

            if (values[0] is XamComboEditor)
                comboEditor = (XamComboEditor)values[0];
            if (values[1] is int)
                selectedCount = (int)values[1];

            if (comboEditor == null && selectedCount == -1)
                return false;

            if (selectedCount == comboEditor.Items.Count)
                return true;

            return false;
        }


        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {

            return null;
        }
    }

    public class ReducedValue : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {


            var p = double.Parse((string)parameter);
            return ((double)value - p);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return true;
        }
    }
}
